Add Array#overlap? for whether the intersection of 2 arrays is non empty?
07/02/2019 02:09 PM - fcheung (Frederick Cheung)

Status: Feedback
Priority: Normal
Assignee:

Target version:

Description
This is semantically equivalent to (ary1 & ary2).any?, but more efficient and makes the intent more obvious.

For example bundler checks whether the list of requested groups and the list of groups for a dependency has any overlap - it doesn't
care what the overlap is, as long as it is non empty

In my personal projects we've found this to be a bottleneck when the arrays are large and where intersections are likely - !(ary1 &
ary2).empty? keeps searching for all of the intersection even after we've found the first one, & creates extra garbage because of the
intermediate array.

See https://github.com/ruby/ruby/pull/2260

Related issues:
Is duplicate of Ruby master - Feature #15198: Array#intersect? Open

History

#1 - 07/02/2019 03:06 PM - fcheung (Frederick Cheung)

- Subject changed from Add Array#overlaps? for whether the intersection of 2 arrays is non empty? to Add Array#overlap? for whether the intersection
of 2 arrays is non empty?

- File 2260.patch added

#2 - 07/02/2019 03:06 PM - fcheung (Frederick Cheung)
- File deleted (2260.patch)

#3 - 07/02/2019 04:12 PM - shevegen (Robert A. Heiler)

To me the name of the method appears to make sense and | am slightly in
favour of the suggestion. | can not say how useful this method would be

in general, though, mostly because | think | needed to do something

such as (array1 & array2).any? perhaps only once or twice in a long

time in my own code; but even then | think this might be a useful

proposal and a name that makes sense (to me at the least).

#4 - 07/02/2019 09:02 PM - fcheung (Frederick Cheung)
- File deleted (2260.patch)
- File 2260.patch added

#5 - 07/02/2019 09:03 PM - fcheung (Frederick Cheung)
- Description updated

#6 - 07/02/2019 09:05 PM - fcheung (Frederick Cheung)

shevegen (Robert A. Heiler) wrote:

To me the name of the method appears to make sense and | am slightly in
favour of the suggestion. | can not say how useful this method would be

in general, though, mostly because | think | needed to do something

such as (array1 & array2).any? perhaps only once or twice in a long

time in my own code; but even then | think this might be a useful

proposal and a name that makes sense (to me at the least).

Thanks. Matz suggested today that the name was not so clear to him. An alternative that springs to mind would be intersect?, but | am obviously open
to any suggestions
https://github.com/ruby/ruby/blob/master/lib/bundler/runtime.rb#L61
https://github.com/ruby/ruby/pull/2260

#7 - 07/27/2019 09:13 AM - janosch-x (Janosch Miiller)

| think this should be called intersect? for consistency with Set#intersect? and SortedSet#intersect?.

#8 - 09/02/2019 07:02 AM - matz (Yukihiro Matsumoto)
- Status changed from Open to Feedback

| don't think overlap? is a good name. Besides that, Array#overlap? creates an internal hash table anyway, so that it wouldn't solve the bottleneck. In
this case, creating a hash table explicitly would perform better.

Matz.

#9 - 09/02/2019 07:04 AM - matz (Yukihiro Matsumoto)
- Is duplicate of Feature #15198: Array#intersect? added

Files

2260.patch 7.9 KB 07/02/2019 fcheung (Frederick Cheung)
